# This file is part of the QIMSI QL interface support software
#
# Copyright (C) 2023 Peter Graf
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

# crtinit.s
#
# Set up C-Runtime environment for Q68

    .section .vector
    # Initial stackpointer
    .long _stack_end
    # Initial program counter
    .long start
    #.fill 24,4,0
    .fill 22,4,0
    .long main_int_caller
    .long main_int_caller
    # Level 2 Interrupt Autovector
    .long main_int_caller
    .long main_int_caller
    # Level 4 Interrupt Autovector
    .long main_int_caller
    .long main_int_caller
    # Level 6 Interrupt Autovector -> Level 4 Routine
    .long main_int_caller
    .long main_int_caller
    	
    .section .text
    .global start

start:
    # Video QL Mode 4
    move.l	#0x18063, %a0
    move.b	#4, (%a0)
    
    # Draw a little white line to screen
    # move.l	#0x20080, %a0
    # move.l	#0xFFFFFFFF, (%a0)
    
    # LED on
    move.l	#0x1C000, %a0
    move.b	#1, (%a0)

    # Initialize bss section to zero
    move.l	bss_s, %a0
    move.l	bss_e, %a1
    move.l 	#0, %d0
bss_loop:
    move.l  %d0, (%a0)
    add.l 	#4, %a0
    cmp.l 	%a0, %a1
    bgt  	bss_loop
    nop

    # Call C-function main
    move.l   	c_main, %a0
    jsr 	(%a0)

end_loop:
    bra		end_loop

main_int_caller:
    movem.l 	%d0-%d7/%a0-%a6,-(%a7)
    jsr	_main_int
    movem.l 	(%a7)+,%d0-%d7/%a0-%a6
    rte

    .align 4
bss_s:
    .long _bss_start
bss_e:
    .long _bss_end
c_main:
    .long _main
